unit u_numform;

{$IFDEF FPC}
{$mode objfpc}{$H+}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

interface

uses
  Classes, SysUtils, db, Forms, Controls, Graphics, Dialogs,
  {$IFDEF FPC}
  LazFileUtils,
  {$ENDIF}
  u_framework_components, U_ExtNumEdits, U_ExtOperation, U_ExtOperate,
  u_extconstoperation, u_extmultioperation, U_OnFormInfoIni, u_extdbgrid,
  U_ExtDBPictCombo, IBDatabase, IBCustomDataSet, IBUpdateSQL, IBQuery;

type

  { TFormNumeric }

  TFormNumeric = class(TForm)
    DataSource: TDataSource;
    ExtDBGrid1: TExtDBGrid;
    ExtNumEditAA: TExtDBNumEdit;
    ExtNumEditAB: TExtNumEdit;
    ExtNumEditAC: TExtOperation;
    ExtNumEditBA: TExtNumEdit;
    ExtNumEditBB: TExtNumEdit;
    ExtNumEditBC: TExtOperation;
    ExtNumEditCA: TExtOperation;
    ExtNumEditCB: TExtOperation;
    ExtNumEditCC: TExtOperation;
    ExtNumEditDA: TExtNumEdit;
    ExtNumEditDB: TExtNumEdit;
    ExtNumEditDC: TExtMOperation;
    ExtNumEditEA: TExtOperation;
    ExtNumEditEB: TExtOperation;
    ExtNumEditEC: TExtCOperation;
    ExtOperate1: TExtOperate;
    GroupOperate: TExtOperate;
    ExtOperate2: TExtOperate;
    ExtOperate3: TExtOperate;
    ExtOperate4: TExtOperate;
    ExtOperate5: TExtOperate;
    ExtOperate6: TExtOperate;
    ExtOperate7: TExtOperate;
    ExtOperate8: TExtOperate;
    ExtOperate9: TExtOperate;
    ExtOperateForm: TExtOperateForm;
    IBDatabase: TIBDatabase;
    IBNumbers: TIBQuery;
    IBTransaction: TIBTransaction;
    IBUpdateSQL: TIBUpdateSQL;
    LEqual1: TFWLabel;
    LDivide: TFWLabel;
    LEqual9: TFWLabel;
    LMinus1: TFWLabel;
    LMinus3: TFWLabel;
    LMultiple2: TFWLabel;
    LPlus3: TFWLabel;
    LMultiple: TFWLabel;
    LPlus: TFWLabel;
    LEqual4: TFWLabel;
    LEqual5: TFWLabel;
    LEqual6: TFWLabel;
    LEqual7: TFWLabel;
    LEqual8: TFWLabel;
    LMinus: TFWLabel;
    LEqual: TFWLabel;
    LMinus2: TFWLabel;
    LPlus1: TFWLabel;
    OnFormInfoIni: TOnFormInfoIni;
    procedure ExtDBGrid1KeyPress(Sender: TObject; var Key: char);
    procedure ExtNumEditAAEnter(Sender: TObject);
    procedure ExtNumEditAAExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IBDatabaseBeforeConnect(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormNumeric: TFormNumeric;

implementation

uses fonctions_dbcomponents,fonctions_system;

{ TFormNumeric }

procedure TFormNumeric.FormCreate(Sender: TObject);
begin
  {$IFNDEF FPC}
  IBDatabase.Params.Add('lc_ctype=LATIN1');
  {$ENDIF}
  try
    IBDatabase.Connected := True;
    IBTransaction.Active := True;
    {$IFNDEF FPC}
    IBNumbers.UpdateObject:=IBUpdateSQL;
    {$ENDIF}
    // On cherche ou crée le fichier CSV
    IBNumbers.Open;
    //(TNumericField(IBNumbers.FieldByName('Number'))).DisplayFormat:='#0,99';
  Except
    // Il s'agit d'une entrée/sortie donc on gère les exceptions
    on e:Exception do
      Begin
       MyShowMessage ( fs_remplacemsg ( gs_Error_Bad_Connection,  [E.Message]) );
       Exit;
      end;
  end;
end;

procedure TFormNumeric.ExtNumEditAAExit(Sender: TObject);
begin
  if IBNumbers.State in [dsinsert,dsedit] then
    IBNumbers.Post;
end;

procedure TFormNumeric.ExtDBGrid1KeyPress(Sender: TObject; var Key: char);
begin
  if IBNumbers.Active
  and ( Key = '-' ) Then
   IBNumbers.Delete;
end;

procedure TFormNumeric.ExtNumEditAAEnter(Sender: TObject);
begin
  if IBNumbers.Active then
    IBNumbers.Edit;
end;


procedure TFormNumeric.IBDatabaseBeforeConnect(Sender: TObject);
var lstl_conf : TStringList;
begin
  IBDatabase.DatabaseName:=gs_DefaultDatabase;
  try
    lstl_conf := TStringList.Create;
    lstl_conf.Text := 'RootDirectory='+ExtractSubDir(getAppDir);
    lstl_conf.SaveToFile(ExtractFileDir(Application.ExeName)+DirectorySeparator+'Numeric.conf');
  finally
    lstl_conf.Free;
  end;

end;

end.

